<?php
/*
 * v2, incrementa a partir de la linea 45 un mensaje para revision de spam folder.
 * Se debe crear traducciones en waolicensemanager 
*/
defined( 'ABSPATH' ) or die; 

/// Instanciar clase pestaña en producto (cliente)
function waolm_pestanias_init() {
	if ( is_admin() ) {
		$WAOLM_Pestania = new WAOLM_Pestania();
		$WAOLM_Pestania->init();
	}
}

function inserta_llave_en_thankyoupage($order_id){
        $table_keys = get_post_meta($order_id,'_table_keys',true);
		if($table_keys<>""){
			echo "
			<style>
			h2 {font-size:25px;}
			.tabla{width:90%;}
			.pname, .pversion {
					display:inline-block;
					padding-left:5px;
			}
			.pversion{text-decoration:underline;}
			.plink{height:40px;}
			.par{
					background-color:Gainsboro;
					height:25px;
			}
			.impar{
					background-color:white;
					height:25px;
			}
			.tablekeys thead tr{
					background-color:Gray;
					color:white;
					height:5px;
			}
			tr.plink td p{height:10px;margin-top:-15px;margin-bottom:0px;}
			tr.impar td p{height:10px;margin-top:0px;margin-bottom:0px;}
			tr.par td p{height:10px;margin-top:0px;margin-bottom:0px;}
			</style>";
			$salida = html_entity_decode($table_keys);
			$message = __('You will receive this keys in your inbox email too. If not, please see your <b>spam folder</b>','waolicensemanager');
			$message = str_replace("<b>","<b style='font-weight: bold; color: red; font-size: 24px;'>",$message);
			$message = "<div style='background-color:#EEEEEE;border:solid 1px gray;border-radius:5px;padding:10px;font-size:20px;'>".$message."<i class='fa fa-exclamation' style='font-size:35px;margin-left:10px;color:red;'></i><i class='fa fa-exclamation' style='font-size:35px;margin-left:10px;color:red;'></i><i class='fa fa-exclamation' style='font-size:35px;margin-left:10px;color:red;'></i></div>";
			//$salida .= $message;
			$salida = str_replace("<br>",$message,$salida);
		}else{
			$salida= '<h2><span style="color:#ff0000"><strong>'.__('In a few minutes you will receive your order, if it does not appear in your inbox, please check your SPAM folder.','waolicensemanager').'</strong></span></h2>';
			//add_action( 'woocommerce_thankyou', 'custom_content_thankyou1', 10, 1 );
		}
		echo "<div class='tabla'>";
		echo $salida;
		echo "</div>";
}
function custom_content_thankyou1( $order_id ) {
	//echo '<p>'. __('<p><h2><span style="color:#ff0000"><span style="font-size:15px"><strong>'.__('In a few minutes you will receive your order, if it does not appear in your inbox, please check your SPAM folder.','waolicensemanager').'</strong></span></span></h2></p>').'</p>';
}

//add_action( 'woocommerce_before_thankyou', 'inserta_llave_en_thankyoupage' );
//echo $order->get_payment_method()." xxxxxxxx"; //insertar esto en plugins/woocommerce/templates/checkout/thankyou.php linea 81
add_action( 'woocommerce_thankyou_stripe', 'inserta_llave_en_thankyoupage' );//confirmado para stripe
add_action( 'woocommerce_thankyou_ppec_paypal', 'inserta_llave_en_thankyoupage' );//para paypal checkout
add_action( 'woocommerce_thankyou_cod', 'inserta_llave_en_thankyoupage' ); // cod es para cash on delivery
add_action( 'woocommerce_thankyou_amazon_payments_advanced', 'inserta_llave_en_thankyoupage' ); //para amazon
add_action( 'woocommerce_thankyou_miGpay', 'inserta_llave_en_thankyoupage' ); //para amazon



/*
 * En modo cliente, 2 casos:
 * Siendo tambien servidor: No incluir nada
 * Siendo solo cliente: Crear pagina y subpágina
*/
/// Mostrar las llaves compradas por el cliente en la pagina de edit order
add_action('woocommerce_admin_order_data_after_order_details','susllaves');//sale en edit de order ES FUNCION DE CLIENTE

function susllaves($post)
{//sale en edit de order
	$res1=get_post_meta( $post->id,'_keys' );
	$res=$res1[0];
	//print_r($res);
	//echo "<br>";
	$salida="<div class='form-field form-field-wide wc-customer-user' style='background-color:#fff;border:solid #d7cad2 1px;border-radius:5px;padding:5px;margin-bottom:5px;width:98%'>";
	$salida.="DESPACHO AUTOMATICO:<hr style='color:#d7cad2;'>";
	if(!empty($res1)){
		//$salida="<p class='form-field form-field-wide wc-customer-user'>________</p><h3>".__('The Keys:','woocommerce')."</h3>";
		$salida.="<ul style='list-style: square;margin-left:30px;'>";
		foreach($res as $grupo){
			foreach($grupo as $fila){
				$salida.="<li>".$fila->productname.":  <b>".$fila->skey."</b></li>";
			}//foreach fila END
		}// foreach grupo END
		$salida.="</ul>";
	}else{
		//$salida="<div style='border:solid 1px gray; border-radius:5px;padding:1px 1px 1px 10px;'><p>This order was not autodispatched. Force autodispatch now? <input type='checkbox' id='_dispatchnow' name='_dispatchnow' value='yes'><i>(Check the box and resend completed order.)</i></p></div>";
		$salida.="<table>";
		$salida.="<tr><td width=30%>DESPACHADO:</td><td>NO</td><tr>";
		$salida.="<tr style='background-color:#F6F6F6;'><td>RAZON: </td><td>".get_post_meta($post->id,'_razon',true)."</td></tr>";
		$salida.="<tr><td>ACCION A TOMAR:</td><td>".get_post_meta($post->id,'_accion',true)."</td></tr>";
		$salida.="</table>";
	}
	$salida.="</div>";
	echo  $salida;
}	

if(!soy_waolm_servidor()){
	add_action( 'admin_menu', 'menu_cliente');
}
function menu_cliente(){
//                        title		             menutit	     capacidad	        slug			funcion				logo 	           pos
	add_menu_page('WAOLM License Manager', 'WAOLM Client Setting', 'manage_options','waolm_config','wao_settings_page','dashicons-products', 15);//funcion común en waolicensemanager.php
//                    parent_slug         page_title            menu_title       capability   			menu_slug                     callback              position 
	//add_submenu_page( 'waolm_config', 'Configurar cliente', 'Configurar cliente', 'manage_options', 'waolm_subpage_content', 'waolm_subpage_content',20);
//                        title		             menutit	     capacidad	        slug			funcion				logo 	           pos
}

//FUNCIONES DE CLIENTE PAIS CON SERVIDOR ASIGNADO EN MISMO DOMAIN
function return_local_server_keys($sku){
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
		$args = array(
				'numberposts'	=> -1,
				'meta_key'		=> '_waolm_sku',
				'meta_value'	=> $sku,
				'post_type'		=> 'licensemanagerwao',
				'status'		=> 'publish',
				'orderby'		=> 'menu_order',
				'order'			=> 'ASC',
			);

	$lasllaves=get_posts($args);
	$retorno=array();
	$i=0;
	//$fila=array();
	foreach ($lasllaves as $llave){
		$fila[$i] = new stdClass();
		$fila[$i]->id = $llave->ID;
		$fila[$i]->clave = $llave->post_title;
		$fila[$i]->product = get_post_meta($llave->ID,'_product_name',true);
		$fila[$i]->activations = get_post_meta($llave->ID,'_activations',true);
		$fila[$i]->dispatched = get_post_meta($llave->ID,'_dispatched',true);
		$fila[$i]->status = $llave->post_status=='publish'?'Active':'Inactive';
		//$fila[$i]->priority = get_post_meta($llave->ID,'_priority',true);
		$fila[$i]->priority = $llave->menu_order;
		$retorno[]=$fila[$i++];
	}
	if(is_multisite()){
		restore_current_blog();
	}
	return json_encode($retorno);
}
function return_local_products_combo(){
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
		$args = array(
				'numberposts'	=> -1,
				'post_type'		=> 'product',
				'status'		=> 'publish',
				'orderby'		=> 'menu_order',
				'order'			=> 'ASC',
			);
	$productos=get_posts($args);

	global $wpdb;
	//$q="SELECT ID, post_title FROM {$wpdb->prefix}posts WHERE `post_type` = 'product' AND `post_status` = 'publish'";
	$q="SELECT ID, post_title 
		FROM {$wpdb->prefix}posts
		WHERE post_type = 'product'
		   AND post_status = 'publish'
		   AND ID IN (
			SELECT M.meta_value
				FROM {$wpdb->prefix}posts P, {$wpdb->prefix}postmeta M
				WHERE P.post_type = 'licensemanagerwao'
				  AND P.post_status = 'publish'
				  AND P.ID = M.post_id
				  AND M.meta_key = '_product'
			);";
	$resultados=$wpdb->get_results($q);
	$retorno=array();
	$i=0;
	foreach ($resultados as $res){
		$fila[$i] = new stdClass();
		$fila[$i]->sku = get_post_meta($res->ID,'_sku',true);
		$fila[$i]->post_title = $res->post_title;
		$retorno[]=$fila[$i++];
	}
	if(is_multisite()){
		restore_current_blog();
	}
	return json_encode($retorno);
	//preparar respuesta json
	//insertar la respuesta en una page con shortcode
}
function cuantas_llaves_server_local($product_sku,$variation){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
	global $wpdb;
	$q="SELECT COUNT(meta_value)
		FROM {$wpdb->prefix}postmeta
		WHERE meta_key = '_activations'
		  AND meta_value >= {$variation}
		  AND post_id IN (
			SELECT post_id
				FROM {$wpdb->prefix}postmeta
				WHERE meta_key = '_waolm_sku'
				  AND meta_value = '{$product_sku}')"; 
	  
	$var=$wpdb->get_var($q);
	if(is_multisite()){
		restore_current_blog();
	}
	//update_blog_option(1,'_depu',$q);
	return $var[0];
	//return $var[0]>0?$var[0]:1; 
}
function lasllaves_server_local($product_sku,$variation,$quantity,$priority){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
	global $wpdb;
	$margen=5;
	$q="SET @numero=0";//@numero:=@numero+1 AS nro,
	$s = $wpdb->get_var($q);	  
	$q="
	SELECT  P.menu_order AS nro, P.ID AS keyid, P.post_title AS skey, Q.meta_value AS productname, P.menu_order AS priority, M.meta_value AS product_sku
		FROM {$wpdb->prefix}posts P 
		LEFT JOIN {$wpdb->prefix}postmeta M ON P.ID = M.post_id AND M.meta_key = '_waolm_sku' 
		LEFT JOIN {$wpdb->prefix}postmeta N ON P.ID = N.post_id AND N.meta_key = '_activations'
		LEFT JOIN {$wpdb->prefix}postmeta Q ON P.ID = Q.post_id AND Q.meta_key = '_product_name'
		WHERE P.post_type = 'licensemanagerwao'
		  AND P.post_status = 'publish'
		  AND M.meta_value = '{$product_sku}'
		  AND N.meta_value >= {$variation}
		  AND P.menu_order >= {$priority}
		ORDER BY priority ASC
		LIMIT {$quantity}";  
	$r = $wpdb->get_results($q);	  
	if(is_multisite()){
		restore_current_blog();
	}
	return json_encode($r);
}//function END
function activaciones_server_local($skey,$product_sku,$variation,$nro){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	$retorno=1;
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
	global $wpdb;
	//necesitamos obtener el id a partir del sku recibido.
	//$args = array('numberposts'=>1,'post_title'=>$skey,'post_type'=>'licensemanagerwao', 'post_status'=>'publish','meta_key'=>'_waolm_sku','meta_value'=>$product_sku,'meta_compare'=>'=');
	$tp=$wpdb->prefix;	
	$q="SELECT P.ID
		FROM ".$tp."posts P, ".$tp."postmeta M
		WHERE P.ID = M.post_id
		  AND P.post_title = '".$skey."'
		  AND P.post_type = 'licensemanagerwao'
		  AND P.post_status = 'publish'
		  AND M.meta_key = '_waolm_sku'
		  AND M.meta_value = '".$product_sku."'";
	$waolmkey_id=$wpdb->get_var($q);
	//$waolmkey=get_posts($args); $waolmkey_id=$waolmkey[0]->ID;
	$nuevo = get_post_meta($waolmkey_id, '_activations');
	$nuevo = (int)$nuevo[0] - $variation;
	if(!update_post_meta($waolmkey_id, '_activations',$nuevo)){$retorno=0;}

	$nuevo = get_post_meta($waolmkey_id, '_dispatched');
	$nuevo = (int)$nuevo[0] + $variation;
	if(!update_post_meta($waolmkey_id, '_dispatched',$nuevo)){$retorno=0;}
	if(is_multisite()){
		restore_current_blog();
	}
	return $retorno;
}//function actualiza END
